//////////////////////////////////////////////////////////////////////////
//
// pgScript - PostgreSQL Tools
// RCS-ID:      $Id: pgsLogStmt.h,v 1.1 2008/06/27 18:19:16 pgunittest Exp $
// Copyright (C) 2008 The pgScript Development Team
// This software is released under the Artistic Licence
//
//////////////////////////////////////////////////////////////////////////


#ifndef PGSLOGSTMT_H_
#define PGSLOGSTMT_H_

#include "pgscript/pgScript.h"
#include "pgscript/statements/pgsStmt.h"

class pgsLogStmt : public pgsStmt
{

private:

	const pgsExpression * m_var;
	
	pgsOutputStream & m_cout;

public:

	pgsLogStmt(const pgsExpression * var, pgsOutputStream & cout,
			pgsThread * app = 0);

	virtual ~pgsLogStmt();

	virtual void eval(pgsVarMap & vars) const;

private:

	pgsLogStmt(const pgsLogStmt & that);

	pgsLogStmt & operator=(const pgsLogStmt & that);

};

#endif /*PGSLOGSTMT_H_*/
